version: '3.7'

services:
  profilingapi:
    build: ./profiling/api
    volumes:
      - profilingapideps:/usr/src/app/node_modules
      - ./profiling/api:/usr/src/app
    env_file:
      - ./profiling/api/.env
    depends_on:
      - diseasesapi
      - actionsapi

  diseasesapi:
    build: ./diseases/api
    volumes:
      - diseasesapideps:/usr/src/app/node_modules
      - ./diseases/api:/usr/src/app
    env_file:
      - ./diseases/api/.env
    depends_on:
      - broker
      - cache

  diseasessink:
    build: ./diseases/sink
    volumes:
      - diseasessinkdeps:/usr/src/app/node_modules
      - ./diseases/sink:/usr/src/app
    env_file:
      - ./diseases/sink/.env
    depends_on:
      - broker
      - cache

  actionsapi:
    build: ./actions/api
    volumes:
      - actionsapideps:/usr/src/app/node_modules
      - ./actions/api:/usr/src/app
    env_file:
      - ./actions/api/.env
    depends_on:
      - broker
      - cache

  actionssink:
    build: ./actions/sink
    volumes:
      - actionssinkdeps:/usr/src/app/node_modules
      - ./actions/sink:/usr/src/app
    env_file:
      - ./actions/sink/.env
    depends_on:
      - broker
      - cache

  broker:
    image: nats-streaming:0.18-alpine
    command: --cluster_id broker --store FILE --dir /store/data
    volumes:
      - lake:/store/data
    depends_on:
      - cache

  cache:
    image: mongo:4-bionic

volumes:
  profilingapideps:
  diseasesapideps:
  diseasessinkdeps:
  actionsapideps:
  actionssinkdeps:
  lake:
